Subject: Re: [PATCH 05/16] index-info.c: identify empty input lines in read_index_info

From: Junio C Hamano <[email-masked]>
Date: Tue, 11 Jun 2024 15:52:37 -0700

"Victoria Dye via GitGitGadget" <[email-masked]> writes:

> From: Victoria Dye <[email-masked]>
>
> Update 'read_index_info()' to return INDEX_INFO_EMPTY_LINE (value 1), rather
> than the default error code (value -1) when the function encounters an empty
> line in stdin. This grants the caller the flexibility to handle such
> scenarios differently than a typical error. In the case of 'update-index',
> we'll still exit with a "malformed input line" error. However, when
> 'read_index_info()' is used to process the input to 'mktree' in a later
> patch, the empty line return value will signal a new tree in --batch mode.

Interesting.  We could even introduce "# commented input" but that
is a different story ;-).

I also wonder if we can flip it around and teach read_index_info()
to (1) silently accept and do a callback when it recognises the
input line is one of the supported formats, and (2) send any
unrecognised line, not just an empty one, with "unrecognised" status
code.  That way, the caller can handle more than single kind of
"special input line" more easily, perhaps?

Thanks.